import { type EntityInstance, type FieldInstance, type LayerInstance, type LDTKProject, type Level, type TileInstance, type TilesetDefinition } from './quicktype';
import { BaseParser } from '../../BaseParser';
import { HostConfig } from '../../typedefs/HostConfig';
type Config = HostConfig<FieldInstance, TileInstance, TilesetDefinition, EntityInstance, LayerInstance, Level, LDTKProject>;
/** The parser class. */
export declare class Parser extends BaseParser<Config> {
    /**
     * Compiles an LDtk project.
     *
     * @param ldtkString The string content of the .ldtk file.
     * @returns The compiled LDtk project.
     */
    toLDTKProject(ldtkString: string): LDTKProject;
}
export {};
//# sourceMappingURL=Parser.d.ts.map